<template>
    <v-skeleton-loader
        :loading="loading"
        type="text"
    >
        <v-timeline
            dense
            clipped
        >
            <v-timeline-item
                class="mb-4"
                small
            >
                <v-row justify="space-between">
                    <v-col cols="5">
                        {{ $t('order_', [$t('created')]) }}
                    </v-col>
                    <v-col class="subtitle-1">
                        {{ order.order_at | datetime }}
                    </v-col>
                </v-row>
            </v-timeline-item>

            <template v-if="order.invoice && !isBusinessTypeShop">
                <v-timeline-item
                    class="mb-4"
                    color="primary"
                    small
                >
                    <v-row justify="space-between">
                        <v-col cols="5">
                            <span>{{ $t('surcharge_', [$t('created')]) }}</span>
                            <div class="text-uppercase py-2">{{ order.invoice.currency }}{{ order.invoice.amount | currency }}</div>
                            <v-chip
                                color="primary"
                                text-color="white"
                                label
                                small
                            >
                                {{ $t(order.invoice.status) }}
                            </v-chip>
                        </v-col>
                        <v-col class="subtitle-1">
                            {{ order.invoice.created_at | datetime }}
                        </v-col>
                    </v-row>
                </v-timeline-item>
            </template>

            <template v-if="order.invoice && isBusinessTypeShop">
                <v-timeline-item
                    class="mb-4"
                    color="primary"
                    small
                >
                    <v-row justify="space-between">
                        <v-col cols="5">
                            <span>{{ $t('invoice_', [$t('created')]) }}</span>
                            <div class="text-uppercase py-2">{{ order.invoice.currency }}{{ order.invoice.amount | currency }}</div>
                            <v-chip
                                color="primary"
                                text-color="white"
                                label
                                small
                            >
                                {{ $t(order.invoice.status) }}
                            </v-chip>
                        </v-col>
                        <v-col class="subtitle-1">
                            {{ order.invoice.created_at | datetime }}
                        </v-col>
                    </v-row>
                </v-timeline-item>
            </template>

            <template v-if="invalidedOrder">
                <v-timeline-item
                    class="mb-4"
                    color="error"
                    small
                >
                    <v-row justify="space-between">
                        <v-col cols="5">
                            <span>{{ $t('order_', [$t(order.status.name)]) }}</span>
                            <div
                                v-if="!!order.reason"
                                class="field-label subtitle-2 pt-2 text-wrap"
                            >
                                <strong>{{ order.reason }}</strong>
                            </div>
                        </v-col>
                        <v-col class="subtitle-1">
                            {{ order.updated_at | datetime }}
                        </v-col>
                    </v-row>
                </v-timeline-item>
            </template>

            <template v-else>
                <v-timeline-item
                    class="mb-4"
                    :color="!order.approved_at ? 'grey' : 'primary'"
                    small
                >
                    <v-row justify="space-between">
                        <v-col cols="5">
                            {{ $t('order_', [$t('approved')]) }}
                        </v-col>
                        <v-col class="subtitle-1">
                            {{ order.approved_at | datetime }}
                        </v-col>
                    </v-row>
                </v-timeline-item>

                <v-timeline-item
                    class="mb-4"
                    :color="!order.shipping_at ? 'grey' : 'primary'"
                    small
                >
                    <v-row justify="space-between">
                        <v-col cols="5">
                            {{ $t('order_', [$t('shipping')]) }}
                        </v-col>
                        <v-col class="subtitle-1">
                            {{ order.shipping_at | datetime }}
                        </v-col>
                    </v-row>
                </v-timeline-item>

                <v-timeline-item
                    class="mb-4"
                    :color="!order.shipped_at ? 'grey' : 'primary'"
                    small
                    v-if="!isBusinessTypeShop"
                >
                    <v-row justify="space-between">
                        <v-col cols="5">
                            {{ $t('order_', [$t('delivered')]) }} {{ ($t('in_use')) }}
                        </v-col>
                        <v-col class="subtitle-1">
                            {{ order.shipped_at | datetime }}
                        </v-col>
                    </v-row>
                </v-timeline-item>

                <v-timeline-item
                    class="mb-4"
                    :color="!order.return_at ? 'grey' : 'primary'"
                    small
                    v-if="isBusinessTypeShop"
                >
                    <v-row justify="space-between">
                        <v-col cols="5">
                            {{ $t('order_', [$t('delivered')]) }} {{($t('completed'))}}
                        </v-col>
                        <v-col class="subtitle-1">
                            {{ order.return_at | datetime }}
                        </v-col>
                    </v-row>
                </v-timeline-item>

                <v-timeline-item
                    class="mb-4"
                    :color="!order.pick_up_requested_at ? 'grey' : 'primary'"
                    small
                    v-if="!isBusinessTypeShop"
                >
                    <v-row justify="space-between">
                        <v-col cols="5">
                            {{ $t('order_', [$t('pick_up_requested')]) }}
                        </v-col>
                        <v-col class="subtitle-1">
                            {{ order.pick_up_requested_at | datetime }}
                        </v-col>
                    </v-row>
                </v-timeline-item>

                <v-timeline-item
                    class="mb-4"
                    :color="!order.return_at ? 'grey' : 'primary'"
                    small
                    v-if="!isBusinessTypeShop"
                >
                    <v-row justify="space-between">
                        <v-col cols="5">
                            {{ $t('order_', [$t('return')]) }}
                        </v-col>
                        <v-col class="subtitle-1">
                            {{ order.return_at | datetime }}
                        </v-col>
                    </v-row>
                </v-timeline-item>
            </template>
        </v-timeline>
    </v-skeleton-loader>
</template>

<script>
    import OrderStatus from '../../../constants/order'
    import BusinessType from '../../../constants/businessType'
    import TimeslotType from '../../../constants/timeslot'

    export default {
        name: 'OrderTimeline',
        props: {
            loading: {
                type: Boolean,
                default: false
            },
            order: {
                type: Object,
                default: () => ({})
            }
        },
        data: () => ({
            timeslotType: TimeslotType.RETURN,
            pickupTimeslot : null
        }),
        computed: {
            invalidedOrder() {
                const status = this.order.status.id;

                return status === OrderStatus.CANCELLED
                    || status === OrderStatus.REFUND
                    || status === OrderStatus.REJECTED
                    || status === OrderStatus.FAILED
            },
            isBusinessTypeShop() {
                const shopBusinessType = this.order.business_type_id === BusinessType.SHOP;

                return shopBusinessType;
            },
        },
    }
</script>

<style scoped>

</style>
